﻿/// <reference path="../web/jquery/jquery.d.ts" />
/// <reference path="sShare.ts" />

interface Navigator {
    //webkitGetUserMedia: any;//不知道什么原因，这里有警告 
    camera: any;   //摄像头的定义
}
var Camera: any;

var acUserInfo: ArrayConstructor;
var acJobCodes: ArrayConstructor;
var acTimeCards: ArrayConstructor;
var currentTime: Date;
var timeFormat: string = "0";
var timer: number;
var toio: string = "";
var clockId: string = window.localStorage.getItem('clockID');
var sUserName: string = getvalue('acUser')[0]['UserName'];
var sPassword: string = getvalue('acUser')[0]['Password'];
var employeeId: number = getvalue("acUser")[0].ID;
var companyId: number = getvalue("acUser")[0].CompanyID;
var timeZone: string = getvalue('acUser')[0]['TimeZone'];
var jobCode: string = "";
var shiftReport: string = "";

var sUrl: string = window.localStorage.getItem('sUrl');  //获取页面的url地址
var jobData: any;
var ip: string = "";
var sDefaultJob: string = "";
var sDefaultShift: string = "";

var latitude: string = "";      //经纬度定义。。。。
var longitude: string = "";
var latitudeZone: string = "";      //经纬度定义。。。。
var longitudeZone: string = "";
var userId: string = "";

var native: string = window.location.toString(); // 用于判断是用ipad，iPhone，Android还是windows  登录的
var sRefresh: any;
var sIndex: number = -1;
var sAddress: string = "";

class index {                                //使用vs2015编码在不同的页面中如果有相同的方法必须用class xxx 来区分。
    static init() {
        index.getUserInfo();
        index.getIp();
        index.getTodayTimeCards();
        if (getvalue("acCompanys")[0]['GpsEnabled'] == "1") {
            $("#divGPS").show();
            $("#divGPS").html("GPS: na <br/>");
            index.getGps();
        }
        $("#lblClockId").html(clockId);
        $("#lblName").html(getvalue("acUser")[0]['Name']);
    }

    static getGps() {
        navigator.geolocation.getCurrentPosition(index.onGpsSuccess, index.onGpsError, { maximumAge: 300000, timeout: 5000, enableHighAccuracy: true });
    }

    static onGpsSuccess(position) {
        if (parseFloat(position.coords.latitude).toFixed(2) == latitudeZone && parseFloat(position.coords.longitude).toFixed(2) == longitudeZone) { 
            //$("#divGPS").html("<span>GPS: " + sAddress + " (" + latitudeZone + " ," + longitudeZone + ")</span>");
            return;
        }

        latitudeZone = parseFloat(position.coords.latitude).toFixed(2);
        longitudeZone = parseFloat(position.coords.longitude).toFixed(2);
        if (latitudeZone == "" || longitudeZone == "") {
            setTimeout(function () {
                index.getGps();
            }, 5000);
            return;
        }

        latitude = parseFloat(position.coords.latitude).toFixed(4);
        longitude = parseFloat(position.coords.longitude).toFixed(4);

        
        $("#divGPS").html("<a href='#' onclick='index.getAddress()'>GPS: (lat " + latitudeZone + ", lon " + longitudeZone + ")</a><br/>");
        setTimeout(index.getGps, 300000);
    }

    static onGpsError(error) {
        setTimeout(function () {
            index.getGps();
        }, 5000);
    }

    static getAddress() {
        $("#divGPS").html("loading ...<br/>");
        $.post(sUrl + "back/sGetAddress2.php", { "latitude": latitudeZone, "longitude": longitudeZone }, function (data) {
            sAddress = JSON.parse(data);
            $("#divGPS").html("<span>GPS: " + sAddress + " (" + latitudeZone + " ," + longitudeZone+")</span>");
        });
    }

    static getTodayTimeCards() {
        $("#tblTodayTimeCards").html("loading ...");
        $.post(sUrl+"back/sGetTodayTimeCards.php", { "employeeId": employeeId, "userName": sUserName, "Password": sPassword, "TimeZone": timeZone }, function (data) {
            data = JSON.parse(data);
            acTimeCards = eval(data);
            var html: string = "";
            html += "<thead><tr><th>" +
                    "<div style='width:15%;float:left;'>#</div>" +
                    "<div style='width:25%;float:left;'>IN</div>" +
                    "<div style='width:25%;float:left;'>OUT</div>" +
                    "<div style='width:20%;float:left;'>Total</div>" +
                    "<div style='width:15%;float:left;'>&nbsp;</div>" +
                    "</th></tr></thead>";
            for (var i = 0; i < data.length; i++) {
                html += "<tr>" +
                "<td index='" + i +"'>" +
                    "<div style='width:15%;float:left;'> " + (i + 1) + "</div>" +
                    "<div style='width:25%;float:left;'>";
                    var InDateTime = data[i]['InDateTime'].substr(11, 5);
                    if (getvalue("acCompanys")[0].TimeFormat == "0") {
                        var Hours = string2hours(InDateTime.substr(0, 2));
                        var Minute = InDateTime.substr(3, 2);
                        var ap = hours2ampm(InDateTime.substr(0, 2));
                        html += Hours + ":" + Minute + " " + ap;
                    } else {
                        html += InDateTime;
                    }
                    html += "</div>" +
                    "<div style='width:25%;float:left;'>";
                    var OutDateTime = data[i]['OutDateTime'].substr(11, 5);
                    if (data[i]['OutDateTime'] == "0000-00-00 00:00:00")
                        html += "<span style='color:red;'>missing</span>";
                    else if (getvalue("acCompanys")[0].TimeFormat == "0") {
                        var Hours = string2hours(OutDateTime.substr(0, 2));
                        var Minute = OutDateTime.substr(3, 2);
                        var ap = hours2ampm(OutDateTime.substr(0, 2));
                        html += Hours + ":" + Minute + " " + ap;
                    } else {
                        html += OutDateTime;
                    }
                    html += "</div>" +
                    "<div style='width:20%;float:left;'>";
                        var hours: string = data[i].HoursTime;
                        if (hours < '0' || hours > '24')
                            hours = '0';
                        html += getTimeTotalsFormat(hours);
                    html += "</div>" +
                    "<div style='width:15%;float:left;'>";
                        if (getvalue('acUser')[0].Role == "Manager") {
                            html += "<a href='#' action='edit' style='text-decoration:underline'>comm</a>"
                        } else {
                            html += "<a href='#' action='edit' style='text-decoration:underline'>note</a>"
                        }
                    html += "</div>";
                        if ((data[i].EmployeeNotes != "" && data[i].EmployeeNotes != null) || (data[i].ManagerComments != "" && data[i].ManagerComments != null)) {
                            html += "<div style='text-align:left;width:100%;margin-left:0px;float:left;'>";
                            if (getvalue("acUser")[0].Role == "Manager") {
                                html += index.noteCommentManager(data[i].EmployeeNotes, data[i].ManagerComments, data[i].LightNotes, data[i].ID, data[i].Name);
                            } else {
                                html += index.noteCommentEmployee(data[i].EmployeeNotes, data[i].ManagerComments, data[i].LightComments, data[i].ID, data[i].Name);
                            }
                            html += "</div>";
                        }
            html += "</td>" +
            "</tr>";
            }
            html += "</tbody>";
            $("#tblTodayTimeCards").html(html);
        });
    }

    static noteCommentManager(note: string, comment: string, noteIsRead: string, timeCardId: string, userName: string): string {
        var comIsRead: boolean = false;
        if (noteIsRead == "1")
            comIsRead = true;
        var html: string = "";
        if ((!comIsRead) && note != "" && note != null) {
            html += "<br/><div onclick='btnCloseEmployee_click(" + timeCardId +");' style='color:#FA1212;background:#dff0d8;cursor:pointer;text-decoration:underline;'><span style='font-weight:bold;margin-left:20px;'>" + userName + ": </span>" + note + "</div>";
        } else if (note != "" && note != null)
            html += "<div style='color:#aaaaaa;font-style:italic;'>&nbsp;&nbsp;&nbsp;&nbsp;<span style='font-weight:bold;'>" + userName + ": </span>" + note + "</div>";
        if (comment != "" && comment != null)
            html += "<div style='color:#aaaaaa;font-style:italic;'>&nbsp;&nbsp;&nbsp;&nbsp;<span style='font-weight:bold;'>Manager: </span>" + comment + "</div>";

        return html;
    }

    static noteCommentEmployee(note: string, comment: string, commentIsRead: string, timeCardId: string, userName: string): string {
        var comIsRead: boolean = false;
        if (commentIsRead == "1")
            comIsRead = true;
        var html: string = "";
        if (note != "" && note != null)
            html += "<div style='color:#aaaaaa;font-style:italic;'>&nbsp;&nbsp;&nbsp;&nbsp;<span style='font-weight:bold;'>" + userName + ": </span>" + note + "</div>";
        if ((!comIsRead) && comment != "" && comment != null)
            html += "<div onclick='btnCloseManager_click(" + timeCardId + ");' style='color:#FA1212;background:#dff0d8;cursor:pointer;text-decoration:underline;'><span style='font-weight:bold;margin-left:20px;'>Manager: </span>" + comment + "</div>";
        else if (comment != "" && comment != null)
            html += "<div style='color:#aaaaaa;font-style:italic;'>&nbsp;&nbsp;&nbsp;&nbsp;<span style='font-weight:bold;'>Manager: </span>" + comment + "</div>";

        return html;
    }

    static getIp() {
        $.post(sUrl +"back/sGetIp.php", "", function (data) {
            ip = JSON.parse(data);
            $("#lblIp").html(ip);
        });
    }

    static getClockInOut() {
        $("#btnClock").removeClass("btn-success");
        $("#btnClock").removeClass("btn-danger");
        $("#btnClock").removeClass("btn-warning");
        if (toio == 'in') {
            $("#btnClock").addClass("btn-success");
            $("#btnClock").html("CLOCK IN");
        } else if (toio == 'out') {
            $("#btnClock").addClass("btn-danger");
            $("#btnClock").html("CLOCK OUT");
        } else {
            return;
        }
        //return
        index.getJobCode();
    }

    static getUserInfo() {
        $("#btnClock").html("loading ...");
        $("#btnClock").addClass("disabled");
        $.post(sUrl +"back/sGetUserInfo.php", { "user": sUserName, "clockId": clockId }, function (data) {
            //$("#btnClock").removeClass("disabled");
            acUserInfo = JSON.parse(data);
            userId = acUserInfo[0].ID;
            toio = acUserInfo[0].Toio;
            timeFormat = acUserInfo[0].TimeFormat;
            currentTime = string2date(acUserInfo[0].LocalTime);
            index.serverTime();
            clearInterval(timer);
            timer = setInterval(index.serverTime, 1000);
            
            index.getClockInOut();
        });
    }

    static serverTime() {
        currentTime.setSeconds(currentTime.getSeconds() + 1, 0);
        if (timeFormat == "0")
            $("#lblCurrentTime").html(formatAMPM(currentTime));
        else
            $("#lblCurrentTime").html(format24(currentTime));
    }

    static getJobCode() {
        $("#cmbJobCodes").html('<option value="">loading job codes ...</option>');
        $.post(sUrl + "back/sGetJobCodes.php", { "userName": sUserName, "Password": sPassword, "io": toio, "clockId": clockId, "latitudeZone": latitudeZone, "longitudeZone": longitudeZone }, function (data) {
            data = JSON.parse(data);
            jobData = data;
            $("#cmbJobCodes").show();
            $("#txtShiftReport").show();
            $("#btnClock").removeClass("disabled");
            if (data == 'NOTMATCHING') {
                if (toio == "in") {
                    $("#btnClock").html("CLOCK IN");
                } else {
                    $("#btnClock").html("CLOCK OUT");
                }
                alert("Username or password not matching.");
            } else if (data == "NOPERMISSION") {
                if (toio == "in") {
                    $("#btnClock").html("CLOCK IN");
                } else {
                    $("#btnClock").html("CLOCK OUT");
                }
                $("#cmbJobCodes").hide();
                $("#txtShiftReport").hide();
                /*
                $("#dialogHead").html("Not Permitted Location");
                $("#dialogBody").html("Not permitted to clock in/out from this IP address [" + ip + "] or Clock ID [" + clockId +
                    "]. <br/>If your Clock ID keeps changing, we recommend you to download and use the desktop version from:<a target='_blank' href='http://www.opentimeclock.com/download.html'> http://www.opentimeclock.com/download.html</a>");
               */
            }else if (data[0]['JobShiftEnabled'] == '0') {
                acJobCodes = eval(data);
                $("#cmbJobCodes").hide();
                $("#txtShiftReport").hide();
            } else {
                acJobCodes = eval(data);
                var html: string = "";
                if (acJobCodes[0]['JobShiftEnabled'] != '0') {
                    $("#dialogClockBody").show();
                    for (var i: number = 0; i < acJobCodes.length; i++) {
                        if (acJobCodes[i]['Selected'] == "1") {
                            sDefaultJob = acJobCodes[i]['JobCode'];
                            sDefaultShift = acJobCodes[0]['shiftReport'];
                            html += "<option value='" + acJobCodes[i]['JobCode'] + "' selected='selected'>" + acJobCodes[i]['JobCode'] + "</option>";
                        } else {
                            html += "<option value='" + acJobCodes[i]['JobCode'] + "'>" + acJobCodes[i]['JobCode'] + "</option>";
                        }
                    }
                } else {
                    $("#dialogClockBody").hide();
                }
                $("#cmbJobCodes").html(html);
                $("#txtShiftReport").val(data[0]['shiftReport']);

                if (toio == "in") {
                    $("#btnClock").html("CLOCK IN");
                } else {
                    $("#btnClock").html("CLOCK OUT");
                }
            }
        });
    }
    /*
    static imgRefresh_click() {
        if (toio == "in") {
            $("#btnClock").html("CLOCK IN");
        } else {
            $("#btnClock").html("CLOCK OUT");
        }
        $("#btnClock").removeClass("disabled");
        $("#imgRefresh").hide();
    }
    */
}

function btnCloseManager_click(timeCardId: string) {
    $.post(sUrl + "back/eCommentIsRead.php", { "timeCardId": timeCardId, "companyId": getvalue("acUser")[0].CompanyID }, function (data) {
        index.getTodayTimeCards();
    });
}

function btnCloseEmployee_click(timeCardId: string) {
    $.post(sUrl + "back/mEmployeeNoteIsRead.php", { "timeCardId": timeCardId, "companyId": getvalue("acUser")[0].CompanyID }, function (data) {
        index.getTodayTimeCards();
    });
}

function txtShiftReport_focusin() {
    
    if ($("#txtShiftReport").val() =="shift report (optional)" || $("#txtShiftReport").attr('placeholder') == "shift report (optional)") {
        $("#txtShiftReport").val("");
        $("#txtShiftReport").attr('placeholder', "");
    }
}

function txtShiftReport_focusout() {
    if ($("#txtShiftReport").val().trim() == "")
        $("#txtShiftReport").attr("placeholder","shift report (optional)");
}

function btnClock_click() {
    if (jobData == "NOPERMISSION") {
        $("#dialogHead").html("Not Permitted Location");
            $("#dialogBody").html("Not permitted to clock in/out from this IP address ["+ip+"] or Clock ID ["+clockId+
                "]. <br/> Only manager can set the 'permitted locations'");
            $("#dialog").modal('show');
            return;
    }

    if (acJobCodes[0]['JobShiftEnabled'] == "1") {
        if (acJobCodes.length == 1) {
            jobCode = "";
        } else {
            jobCode = $("#cmbJobCodes").val().trim();
        }
        if (acJobCodes[0]['JobShiftEnabled'] == '1' && acJobCodes.length > 1) {
            if (jobCode == "please select job") {
                alert("Please select a job code");
                $("#btnYesClock").html("CLOCK IN");
                return;
            }
        }
        if (jobCode == "please select job") {
            jobCode = "";
        }
        shiftReport = $("#txtShiftReport").val().trim();
        if (shiftReport == "shift report (optional)") {
            shiftReport = "";
        }
    }

    sRefresh= self.setInterval("Refresh()", 35000);
    var clockClass: string = $("#btnClock").attr("class");
    if (clockClass.indexOf("disabled") > 0 || $("#cmbJobCodes").val() == "loading job codes ...") {
        return;
    }

    //$("#imgRefresh").show();
    if ($("#btnClock").html() == "CLOCK IN") {
        toio = "in";
    } else if ($("#btnClock").html() == "CLOCK OUT") {
        toio = "out";
    } else {
        toio = "switch";
    }
    $("#btnClock").html("loading ...");
    $("#btnClock").addClass("disabled");

    if (acJobCodes[0]['cameraRequired'] != "0") {
        if (native.indexOf("http") != -1) {
            alert("Camera was set to be required by your manager. But your web browser doesn't support camera. Please" +
                " search 'timeclockfree' in app store for installing native app.");
            if (toio == "in") {
                $("#btnClock").html("CLOCK IN");
            } else if (toio == "out") {
                $("#btnClock").html("CLOCK OUT");
            } else {
                $("#btnClock").html("SWITCH JOB"); 
            }
            $("#btnClock").removeClass("disabled");
            window.clearInterval(sRefresh);
        } else {
            capturePhoto();
        }
    } else {
        yesClock("", "");
    }
}

function Refresh() {
    window.location.href = "sClock.html";
}

function yesClock(fullName: string, imgData:any) {
    $.post(sUrl + "back/sClock.php", { "fullName": fullName, "imgData": imgData, "userName": sUserName, "Password": sPassword, "clockId": clockId, "io": toio, "jobCode": jobCode, "shiftReport": shiftReport, "Latitude": latitude, "Longitude": longitude }, function (data) {
        data = JSON.parse(data);
        $("#imgCorrect").attr("src", "images/correct120.png");
        $("#divCorrect").show();
        window.clearInterval(sRefresh);
        setTimeout(function () {
            $("#btnClock").removeClass("disabled");
            $("#divCorrect").hide();
            index.getUserInfo();
            index.getTodayTimeCards();
        }, 2000);
    });
}

function onPhotoDataSuccess(imageData) {
    // base64 encoded image data
    //var smallImage = document.getElementById('smallImage');
    //smallImage.style.display = 'block';
    //在使用base64编码的时候需要使用这样的前缀
    $("#smallImage").attr("src", "data:image/jpeg;base64," + imageData);
    $("#divImage").show();
    yesClock("", imageData);
}

function onFail(message) {
    if (toio == "in") {
        $("#btnClock").html("CLOCK IN");
    } else {
        $("#btnClock").html("CLOCK OUT");
    }
    $("#btnClock").removeClass("disabled");
    window.clearInterval(sRefresh);
    //alert('Failed because: ' + message);
}

function capturePhoto() {
    navigator.camera.getPicture(onPhotoDataSuccess, onFail, {
        quality: 100,
        destinationType: Camera.DestinationType.DATA_URL,
        cameraDirection: Camera.Direction.FRONT,
        //cameraDirection: Camera.Direction.BACK,
        targetWidth: 180,
        targetHeight: 180,
        saveToPhotoAlbum: false,
        correctOrientation: true
    });
}

function btnAuthorizen_click() {
    $("#dialogAuthorizenHead").html("Authorize this device for clock in");
    $("#cmbAuthorizenType").val("0");
    $("#divAuthorizen").html("<input id='txtAuthorizen' type= 'text' class='form-control' style= 'width:260px;' disabled>");
    $("#txtAuthorizen").val(ip);
    $("#dialogAuthorizen").modal("show");
    $("#dialog").modal("hide");
}

function btnAuthorizeSave_click() {
    if ($("#btnAuthorizeSave").attr("disabled") == "disabled")
        return;

    var cmbAuthorizenType: string = $("#cmbAuthorizenType").val();

    var clock: string = $("#txtAuthorizen").val();

    if (clock == "" || clock == ", ") {
        $("#dialogBody").html("Please input device.");
        $("#dialog").modal("show");
        return;
    }
    var userManagerName: string = $("#txtManagerUserName").val();
    var managerPassword: string = $("#txtManagerPassword").val();
    $("#btnAuthorizeSave").addClass("disabled");
    $("#btnAuthorizeSave").html("loading ...");
    $.post(sUrl + "back/mAddPermittedLocation.php", { "cmbAuthorizeDevice": cmbAuthorizenType, "userId": userId,"companyId": companyId, "userManagerName": userManagerName, "managerPassword": managerPassword, "clock": clock }, function (data) {
        $("#btnAuthorizeSave").html("authorize");
        $("#btnAuthorizeSave").removeClass("disabled");
        if (data == '"ERROR"') {
            alert("manager username or password error.");
            return;
        }
        $("#dialogAuthorizen").modal("hide");
        index.getUserInfo();
        index.getTodayTimeCards();
    });
}

function cmbJobCodes_change() {
    $("#btnYesClock").removeClass("btn-success");
    $("#btnYesClock").removeClass("btn-danger");
    $("#btnYesClock").removeClass("btn-warning");
    if (toio == "out") {
        if ($("#cmbJobCodes").val() == sDefaultJob) {
            $("#btnClock").removeClass("btn-success");
            $("#btnClock").removeClass("btn-danger");
            $("#btnClock").removeClass("btn-warning");

            $("#btnClock").addClass("btn-danger");
            $("#btnClock").html("CLOCK OUT");
            $("#txtShiftReport").val(sDefaultShift);
        } else {
            $("#btnClock").removeClass("btn-success");
            $("#btnClock").removeClass("btn-danger");
            $("#btnClock").removeClass("btn-warning");

            $("#btnClock").addClass("btn-warning");
            $("#btnClock").html("SWITCH JOB");
            $("#txtShiftReport").val("shift report (optional)");
        }
    }
}

function lnkEditComment_click() {
    sIndex= Number($(this).parent().parent().attr("index"));
    if (getvalue("acUser")[0].Role == "Manager") {
        $("#dialogEditHead").html("edit comment");
        $("#lblCommentTitle").html("comment:");
        $("#txtManagerComment").val(acTimeCards[sIndex].ManagerComments);
    } else {
        $("#dialogEditHead").html("edit note");
        $("#lblCommentTitle").html("note:");
        $("#txtManagerComment").val(acTimeCards[sIndex].EmployeeNotes);
    }

    $("#btnSave").html("Save");
    $("#btnSave").removeClass("disabled");
    $("#dialogEdit").modal("show");
}

function btnSave_click() {
    
    if ($("#btnSave").attr("disabled") == "disabled")
        return;
    var managerComment: string = $("#txtManagerComment").val().trim();
    managerComment = notes(managerComment);

    $("#btnSave").html("loading ...");
    $("#btnSave").addClass("disabled");
    $.post(sUrl + "back/mEditManagerComment.php", { "timeCardId": acTimeCards[sIndex].ID, "employeeId": employeeId, "managerComment": managerComment, "Role": getvalue("acUser")[0].Role, "companyId": companyId }, function (data) {
        $("#imgDone").show();
        setTimeout(function () {
            $("#dialogEdit").modal("hide");
            $("#imgDone").hide();
            $("#btnSave").removeClass("disabled");
            index.getTodayTimeCards();
        }, 500);
    });
}

function cmbAuthorizenType_change() {
    $("#divAuthorizen").html("<input id='txtAuthorizen' type= 'text' class='form-control' style= 'width:260px;' disabled>");
    if ($("#cmbAuthorizenType").val() == "0") {
        $("#txtAuthorizen").val(ip);
    } else if ($("#cmbAuthorizenType").val() == "1") {
        $("#txtAuthorizen").val(clockId);
    } else if ($("#cmbAuthorizenType").val() == "2") {
        $("#divAuthorizen").html("<input id='txtAuthorizen' type= 'text' class='form-control' style= 'width:260px;'>");
        $("#txtAuthorizen").val("");
    } else if ($("#cmbAuthorizenType").val() == "3") {
        $("#txtAuthorizen").val(latitudeZone + ", " + longitudeZone);
    }
}

$(function () {
    index.init();
    $("#txtShiftReport").focusin(txtShiftReport_focusin);
    $("#txtShiftReport").focusout(txtShiftReport_focusout);
    $("#btnClock").click(btnClock_click);

    $("#btnAuthorizen").click(btnAuthorizen_click);
    $("#btnAuthorizeSave").click(btnAuthorizeSave_click);
    $("#cmbJobCodes").change(cmbJobCodes_change);

    $("#cmbAuthorizenType").change(cmbAuthorizenType_change);

    $("#tblTodayTimeCards").on("click", "[action='edit']", lnkEditComment_click);
    $("#btnSave").click(btnSave_click);
});